<?php

@set_time_limit(18000);
if(eregi("ispapi.php",getenv("SCRIPT_NAME"))){session_unregister("newuid");session_unregister("LoggedIn");exit;}

function ispapi_module_install(){
	$res=add_module("ispapi","ISPAPI","registry","Username","text","","Password","password","","","","","","","","","","","","","","","api.ispapi.net/api/call.cgi?s_entity=54cd","api.ispapi.net/api/call.cgi?s_entity=1234","2");
	return $res;
}

function ispapi_register($params){
	$ispapi_config = ispapi_config($params);
	$contact = array(
		"ORGANIZATION" => $params["profile"]["org"],
		"FIRSTNAME" => $params["profile"]["fname"],
		"LASTNAME" => $params["profile"]["lname"],
		"STREET" => $params["profile"]["add1"],
		"CITY" => $params["profile"]["city"],
		"STATE" => $params["profile"]["state"],
		"ZIP" => $params["profile"]["zip"],
		"COUNTRY" => $params["profile"]["country"],
		"PHONE" => $params["profile"]["phone"],
		"FAX" => $params["profile"]["fax"],
		"EMAIL" => $params["profile"]["email"]
	);
	if ( strlen($params["profile"]["add2"]) ) {
		$contact["STREET"] .= " , ".$params["profile"]["add2"];
	}

	$command = array(
		"COMMAND" => "AddDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"PERIOD" => $params["numyears"],
		"NAMESERVER0" => $params["ns1"],
		"NAMESERVER1" => $params["ns2"],
		"NAMESERVER2" => $params["ns3"],
		"NAMESERVER3" => $params["ns4"],
		"OWNERCONTACT0" => $contact,
		"ADMINCONTACT0COPY" => "OWNERCONTACT0",
		"TECHCONTACT0COPY" => "OWNERCONTACT0",
		"BILLINGCONTACT0COPY" => "OWNERCONTACT0",
		"INTERNALDNS" => 1
	);

	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
		$return['transactionid'] = time();

		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["REGISTRATIONEXPIRATIONDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["EXPIRATIONDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["PAIDUNTILDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}


function ispapi_transfer($params){

	$ispapi_config = ispapi_config($params);
	$contact = array(
		"ORGANIZATION" => $params["profile"]["org"],
		"FIRSTNAME" => $params["profile"]["fname"],
		"LASTNAME" => $params["profile"]["lname"],
		"STREET" => $params["profile"]["add1"],
		"CITY" => $params["profile"]["city"],
		"STATE" => $params["profile"]["state"],
		"ZIP" => $params["profile"]["zip"],
		"COUNTRY" => $params["profile"]["country"],
		"PHONE" => $params["profile"]["phone"],
		"FAX" => $params["profile"]["fax"],
		"EMAIL" => $params["profile"]["email"]
	);
	if ( strlen($params["profile"]["add2"]) ) {
		$contact["STREET"] .= " , ".$params["profile"]["add2"];
	}

	$command = array(
		"COMMAND" => "TransferDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"PERIOD" => $params["numyears"],
		"AUTH" => $params["param_array"]["eppkey"],
		"NAMESERVER0" => $params["ns1"],
		"NAMESERVER1" => $params["ns2"],
		"NAMESERVER2" => $params["ns3"],
		"NAMESERVER3" => $params["ns4"],
		"OWNERCONTACT0" => $contact,
		"ADMINCONTACT0COPY" => "OWNERCONTACT0",
		"TECHCONTACT0COPY" => "OWNERCONTACT0",
		"BILLINGCONTACT0COPY" => "OWNERCONTACT0",
	);

	if ( $command["AUTH"] == "-" ) {
		unset($command["AUTH"]);
	}

	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
		$return['transactionid'] = time();
		//you will need to parse and return expiredate in unixtime format
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["REGISTRATIONEXPIRATIONDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["EXPIRATIONDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["PAIDUNTILDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}



function ispapi_transferstatus($params) {
	# Create config for API calls
	$ispapi_config = ispapi_config($params);

	# Check if incoming transfer is still running for given domain
	$command = array(
		"COMMAND" => "QueryTransferList",
		"DOMAIN" => $params["cSld"].".".$params["cTld"]
	);
	$response = ispapi_call($command, $ispapi_config);
	
	# QueryTransferList API call successful?
	if ( $response["CODE"] == 200 ) {

		# Transfer still exists?
		if ( $response["PROPERTY"]["TOTAL"][0] == "0" ) {
			# Domain not in incoming transfer list

			# Check if domain is managed by user
			$command = array(
				"COMMAND" => "StatusDomain",
				"DOMAIN" => $params["cSld"].".".$params["cTld"]
			);
			$response = ispapi_call($command, $ispapi_config);
			
			# PEERUSER existing (but can be empty), if domain belongs to user or subuser
			# PEERUSER defines the subuser chain from current user to object owner
			if ( ($response["CODE"] == 200) && isset($response["PROPERTY"]["PEERUSER"]) ) {
				# Incoming transfer has been completed successfully
				$return['status'] = 1;
				$return['tstatus'] = 'TRANSFER_SUCCESSFUL';
			}

			# API call was successful, but domain does not belong to user
			# 200 or 531: domain managed in backend; 545: Domain not managed in backend
			elseif ( ($response["CODE"] == 200) || ($response["CODE"] == 531) || ($response["CODE"] == 545) ) {
				# Incoming transfer failed
				$return['status'] = 1;
				$return['tstatus'] = 'TRANSFER_FAILED';
			}
			else {
				# Return API error message
				$return['status'] = 2;
				$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
				$return['queue_return'] = htmlspecialchars($response["RAW"]);
				$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
				$return['rawout'] = htmlspecialchars($response["RAW"]);
			}
		}
		else {
			# Incoming transfer is still pending
			$return['status'] = 1;
			$return['tstatus'] = 'TRANSFER_PENDING';
		}
	}
	else {
		# Return API error message
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}

	var_dump($return);

	return $return;

}



function ispapi_renew($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "RenewDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"PERIOD" => $params["numyears"]
	);
	$response = ispapi_call($command, $ispapi_config);

	if ( $response["CODE"] == 510 ) {
		$command["COMMAND"] = "PayDomainRenewal";
		$response = ispapi_call($command, ispapi_config($params));
	}

	if ( $response["CODE"] == 200 ) {
		$status_command = array("COMMAND" => "StatusDomain", "DOMAIN" => $params["cSld"].".".$params["cTld"]);
		$status_response = ispapi_call($status_command, ispapi_config($params));
		if ( $status_response["CODE"] == 200 ) {
			$response["PROPERTY"] = $status_response["PROPERTY"];
		}

		$return['status'] = 1;
		$return['code'] = '1000';
		$return['transactionid'] = time();
		//you will need to parse and return expiredate in unixtime format
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["EXPIRATIONDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["PAIDUNTILDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}

function ispapi_lockdomain($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "ModifyDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"TRANSFERLOCK" => 1
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}


function ispapi_unlockdomain($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "ModifyDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"TRANSFERLOCK" => 0
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}



function ispapi_getinfo($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "StatusDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"]
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
		if ( isset($response["PROPERTY"]["NAMESERVER"]) ) {
			$return['ns1'] = $response["PROPERTY"]["NAMESERVER"][0];
			$return['ns2'] = $response["PROPERTY"]["NAMESERVER"][1];
			$return['ns3'] = $response["PROPERTY"]["NAMESERVER"][2];
			$return['ns4'] = $response["PROPERTY"]["NAMESERVER"][3];
		}

		if ( isset($response["PROPERTY"]["AUTH"]) ) {
			$return['eppkey'] = $response["PROPERTY"]["AUTH"][0];
		}

		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["PAIDUNTILDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}

		if ( isset($response["PROPERTY"]["OWNERCONTACT"]) ) {
			$c = ispapi_contact_info($response["PROPERTY"]["OWNERCONTACT"][0], $ispapi_config);
			foreach ( $c as $key => $value ) {
				$return["Registrant$key"] = $value;
			}
		}
		if ( isset($response["PROPERTY"]["ADMINCONTACT"]) ) {
			$c = ispapi_contact_info($response["PROPERTY"]["ADMINCONTACT"][0], $ispapi_config);
			foreach ( $c as $key => $value ) {
				$return["Admin$key"] = $value;
			}
		}
		if ( isset($response["PROPERTY"]["TECHCONTACT"]) ) {
			$c = ispapi_contact_info($response["PROPERTY"]["TECHCONTACT"][0], $ispapi_config);
			foreach ( $c as $key => $value ) {
				$return["Tech$key"] = $value;
			}
		}
		if ( isset($response["PROPERTY"]["BILLINGCONTACT"]) ) {
			$c = ispapi_contact_info($response["PROPERTY"]["BILLINGCONTACT"][0], $ispapi_config);
			foreach ( $c as $key => $value ) {
				$return["AuxBilling$key"] = $value;
			}
		}
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}


function ispapi_contact_info($contact, &$ispapi_config){
	$c = array();

	if ( isset($ispapi["_contact_hash"][$contact]) )
		return $ispapi["_contact_hash"][$contact];

	$command = array(
		"COMMAND" => "StatusContact",
		"CONTACT" => $contact
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$c = array(
			"JobTitle" => $response["PROPERTY"]["TITLE"][0],
			"FirstName" => $response["PROPERTY"]["FIRSTNAME"][0],
			"LastName" => $response["PROPERTY"]["LASTNAME"][0],
			"OrganizationName" => $response["PROPERTY"]["ORGANIZATION"][0],
			"Address1" => $response["PROPERTY"]["STREET"][0],
			"Address2" => $response["PROPERTY"]["STREET"][1],
			"City" => $response["PROPERTY"]["CITY"][0],
			"StateProvince" => $response["PROPERTY"]["STATE"][0],
			"PostalCode" => $response["PROPERTY"]["ZIP"][0],
			"Country" => strtoupper($response["PROPERTY"]["COUNTRY"][0]),
			"Phone" => $response["PROPERTY"]["PHONE"][0],
			"Fax" => $response["PROPERTY"]["FAX"][0],
			"EmailAddress" => $response["PROPERTY"]["EMAIL"][0],
		);
		if ( (count($response["PROPERTY"]["STREET"]) < 2)
			and preg_match('/^(.*) , (.*)/', $response["PROPERTY"]["STREET"][0], $m) ) {
			$c["Address1"] = $m[1];
			$c["Address2"] = $m[2];
		}
		$ispapi["_contact_hash"][$contact] = $c;
	}
	return $c;
}


function ispapi_getexp($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "StatusDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"]
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1000;
		$return['code'] = '1000';
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		if ( preg_match('/^([1-9][0-9]+)\-([0-9]+)\-([0-9]+)/', $response["PROPERTY"]["PAIDUNTILDATE"][0], $m) ) {
			$return['expiredate'] = mktime(0,0,0,$m[2],$m[3],$m[1]);
		}
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}



function ispapi_updatecontacts($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "ModifyDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
	);
	$map = array(
		"OWNERCONTACT0" => "Registrant",
		"ADMINCONTACT0" => "Admin",
		"TECHCONTACT0" => "Tech",
		"BILLINGCONTACT0" => "AuxBilling"
	);
	foreach ( $map as $c => $p ) {
		$command[$c."ORGANIZATION"] = $params[$p."OrganizationName"];
		$command[$c."TITLE"] = $params[$p."JobTitle"];
		$command[$c."FIRSTNAME"] = $params[$p."FirstName"];
		$command[$c."LASTNAME"] = $params[$p."LastName"];
		$command[$c."STREET"] = $params[$p."Address1"];
		$command[$c."CITY"] = $params[$p."City"];
		$command[$c."STATE"] = $params[$p."StateProvince"];
		$command[$c."ZIP"] = $params[$p."PostalCode"];
		$command[$c."COUNTRY"] = $params[$p."Country"];
		$command[$c."PHONE"] = $params[$p."Phone"];
		$command[$c."FAX"] = $params[$p."Fax"];
		$command[$c."EMAIL"] = $params[$p."EmailAddress"];
		if ( strlen($params[$p."Address2"]) ) {
			$command[$c."STREET"] .= " , ".$params[$p."Address2"];
		}
	}
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}


function ispapi_updatens($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "ModifyDomain",
		"DOMAIN" => $params["cSld"].".".$params["cTld"],
		"INTERNALDNS" => 1,
		"NAMESERVER0" => $params["ns1"],
		"NAMESERVER1" => $params["ns2"],
		"NAMESERVER2" => $params["ns3"],
		"NAMESERVER3" => $params["ns4"],
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}



function ispapi_GetEmailForwarding($params) {
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "QueryDNSZoneRRList",
		"DNSZONE" => $params["cSld"].".".$params["cTld"].".",
		"SHORT" => 1,
		"EXTENDED" => 1
	);
	$response = ispapi_call($command, $ispapi_config);

	$return = array();

	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
		$i = 1;
		foreach ( $response["PROPERTY"]["RR"] as $rr ) {
			$fields = explode(" ", $rr);
			$domain = array_shift($fields);
			$ttl = array_shift($fields);
			$class = array_shift($fields);
			$rrtype = array_shift($fields);

			if ( ($rrtype == "X-SMTP") && ($fields[1] == "MAILFORWARD") ) {
				if ( preg_match('/^(.*)\@$/', $fields[0], $m) ) {
					$address = $m[1];
					if ( !strlen($address) ) {
						$address = "*";
					}
				}
				$return["Username$i"] = $address;
				$return["ForwardTo$i"] = $fields[2];
				$i++;
			}
		}
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}

	return $return;
}


function ispapi_SaveEmailForwarding($params) {
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "UpdateDNSZone",
		"DNSZONE" => $params["cSld"].".".$params["cTld"].".",
		"INCSERIAL" => 1,
		"EXTENDED" => 1,
		"DELRR" => array("@ X-SMTP"),
		"ADDRR" => array(),
	);

	for ( $i = 1; array_key_exists("Username$i", $params); $i++) {
		$prefix = $params["Username$i"];
		$target = $params["ForwardTo$i"];
		if ( strlen($prefix) && strlen($target) ) {
			$redirect = "MAILFORWARD";
			if ( $prefix == "*" ) {
				$prefix = "";
			}
			$redirect = $prefix."@ ".$redirect;
			$command["ADDRR"][] = "@ X-SMTP $redirect $target";
		}
	}

	$response = ispapi_call($command, $ispapi_config);

	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}


function ispapi_GetDNS($params) {
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "QueryDNSZoneRRList",
		"DNSZONE" => $params["cSld"].".".$params["cTld"].".",
		"SHORT" => 1,
		"EXTENDED" => 1
	);
	$response = ispapi_call($command, $ispapi_config);

	$hostrecords = array();

	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
		$i = 1;
		foreach ( $response["PROPERTY"]["RR"] as $rr ) {
			$fields = explode(" ", $rr);
			$domain = array_shift($fields);
			$ttl = array_shift($fields);
			$class = array_shift($fields);
			$rrtype = array_shift($fields);

			if ( $rrtype == "A" ) {
				$hostrecords[$i] = array( "hostname" => $domain, "type" => $rrtype, "address" => $fields[0], );

				if ( !preg_match('/^mxe-host-for-ip-(\d+)-(\d+)-(\d+)-(\d+)$/i', $domain, $m) ) {
					$return["HostName$i"] = $domain;
					$return["TTL$i"] = $ttl;
					$return["RecordType$i"] = $rrtype;
					$return["Address$i"] = implode(" ", $fields);
					$i++;
				}
			}

			if ( $rrtype == "AAAA" ) {
				$return["HostName$i"] = $domain;
				$return["TTL$i"] = $ttl;
				$return["RecordType$i"] = $rrtype;
				$return["Address$i"] = implode(" ", $fields);
				$i++;
			}

			if ( $rrtype == "MX" ) {
				if ( preg_match('/^mxe-host-for-ip-(\d+)-(\d+)-(\d+)-(\d+)($|\.)/i', $fields[1], $m) ) {
					$return["HostName$i"] = $domain;
					$return["TTL$i"] = $ttl;
					$return["RecordType$i"] = "MXE";
					$return["Address$i"] = $m[1].".".$m[2].".".$m[3].".".$m[4];
					$i++;
				}
				else {
					$return["HostName$i"] = $domain;
					$return["TTL$i"] = $ttl;
					$return["RecordType$i"] = $rrtype;
					$return["Address$i"] = implode(" ", $fields);
					$i++;
				}
			}

			if ( $rrtype == "TXT" ) {
				$return["HostName$i"] = $domain;
				$return["TTL$i"] = $ttl;
				$return["RecordType$i"] = $rrtype;
				$return["Address$i"] = implode(" ", $fields);
				$i++;
			}

			if ( $rrtype == "CNAME" ) {
				$return["HostName$i"] = $domain;
				$return["TTL$i"] = $ttl;
				$return["RecordType$i"] = $rrtype;
				$return["Address$i"] = implode(" ", $fields);
				$i++;
			}

			if ( $rrtype == "PTR" ) {
				$return["HostName$i"] = $domain;
				$return["TTL$i"] = $ttl;
				$return["RecordType$i"] = $rrtype;
				$return["Address$i"] = implode(" ", $fields);
				$i++;
			}

			if ( $rrtype == "X-HTTP" ) {
				if ( preg_match('/^\//', $fields[0]) ) {
					$domain .= array_shift($fields);
				}
				$url_type = array_shift($fields);
				if ( $url_type == "REDIRECT" ) $url_type = "URL";

				$return["HostName$i"] = $domain;
				$return["TTL$i"] = $ttl;
				$return["RecordType$i"] = $url_type;
				$return["Address$i"] = implode(" ", $fields);
				$i++;
			}
		}
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}



function ispapi_SaveDNS($params) {
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "UpdateDNSZone",
		"DNSZONE" => $params["cSld"].".".$params["cTld"].".",
		"INCSERIAL" => 1,
		"EXTENDED" => 1,
		"DELRR" => array("% A", "% AAAA", "% CNAME", "% TXT", "% MX", "% PTR", "% X-HTTP"),
		"ADDRR" => array(),
	);

	$mxe_hosts = array();
	for ( $i = 1; array_key_exists("HostName$i", $params); $i++) {
		$hostname = $params["HostName$i"];
		$ttl = $params["TTL$i"];
		$type = $params["RecordType$i"];
		$address = $params["Address$i"];

		if ( strlen($hostname) && strlen($address) ) {
			if ( $type == "A" ) {
				if ( preg_match('/:/', $address ) ) {
					$type = "AAAA";
				}
				else {
					$command["ADDRR"][] = "$hostname $ttl $type $address";
				}
			}
			if ( $type == "AAAA" ) {
				$command["ADDRR"][] = "$hostname $ttl $type $address";
			}
			if ( $type == "CNAME" ) {
				$command["ADDRR"][] = "$hostname $ttl $type $address";
			}
			if ( $type == "PTR" ) {
				$command["ADDRR"][] = "$hostname $ttl $type $address";
			}
			if ( $type == "TXT" ) {
				$command["ADDRR"][] = "$hostname $ttl $type $address";
			}
			if ( $type == "MXE" ) {
				$mxpref = 100;
				if ( preg_match('/^([0-9]+) (.*)$/', $address, $m ) ) {
					$mxpref = $m[1];
					$address = $m[2];
				}

				if ( preg_match('/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/', $address, $m) ) {
					$mxe_host = "mxe-host-for-ip-$m[1]-$m[2]-$m[3]-$m[4]";
					$ip = $m[1].".".$m[2].".".$m[3].".".$m[4];
					$mxe_hosts[$ip] = $mxe_host;
					$command["ADDRR"][] = "$hostname $ttl MX $mxpref $mxe_host";
				}
				else {
					$address = "$mxpref $address";
					$type = "MX";
				}
			}
			if ( $type == "MX" ) {
				$mxpref = 100;
				if ( preg_match('/^([0-9]+) (.*)$/', $address, $m ) ) {
					$mxpref = $m[1];
					$address = $m[2];
				}
				$command["ADDRR"][] = "$hostname $ttl $type $mxpref $address";
			}
			if ( $type == "FRAME" ) {
				$redirect = "FRAME";
				if ( preg_match('/^([^\/]+)(.*)$/', $hostname, $m) ) {
					$hostname = $m[1];
					$redirect = $m[2]." ".$redirect;
				}
				$command["ADDRR"][] = "$hostname $ttl X-HTTP $redirect $address";
			}
			if ( $type == "URL" ) {
				$redirect = "REDIRECT";
				if ( preg_match('/^([^\/]+)(.*)$/', $hostname, $m) ) {
					$hostname = $m[1];
					$redirect = $m[2]." ".$redirect;
				}
				$command["ADDRR"][] = "$hostname $ttl X-HTTP $redirect $address";
			}
		}
	}
	foreach ( $mxe_hosts as $address => $hostname ) {
		$command["ADDRR"][] = "$hostname A $address";
	}

//	var_dump($command);
	$response = ispapi_call($command, $ispapi_config);

	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['code'] = '1000';
	}
	else {
		$return['status'] = 2;
		$return['code'] = $response["CODE"];
		$return['response_text'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}

function ispapi_checkns($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "StatusNameserver",
		"NAMESERVER" => $params["nsname"],
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['is_success'] = 1;
		$return['status'] = 1;
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['name'] = $params["nsname"];
		$return['ipaddress'] = join(" ", $response["PROPERTY"]["IPADDRESS"]);
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}

function ispapi_addns($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "AddNameserver",
		"NAMESERVER" => $params["nsname"],
		"IPADDRESS0" => $params["nsip"]
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}

function ispapi_modns($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "ModifyNameserver",
		"NAMESERVER" => $params["nsname"],
		"DELIPADDRESS0" => $params["oldip"],
		"ADDIPADDRESS0" => $params["newip"],
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}

function ispapi_delns($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "DeleteNameserver",
		"NAMESERVER" => $params["nsname"],
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1;
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
	}
	else {
		$return['status'] = 2;
		$return['error'] = htmlspecialchars($response["DESCRIPTION"]);
		$return['queue_return'] = htmlspecialchars($response["RAW"]);
		$return['response'] = htmlspecialchars($response["CODE"]."-".$response["DESCRIPTION"]);
		$return['rawout'] = htmlspecialchars($response["RAW"]);
	}
	return $return;
}


function ispapi_testconn($params){
	$ispapi_config = ispapi_config($params);
	$command = array(
		"COMMAND" => "StatusAccount",
	);
	$response = ispapi_call($command, $ispapi_config);
	if ( $response["CODE"] == 200 ) {
		$return['status'] = 1000;
		$return['code'] = '1000';
		$return['queue_return'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	else {
		$return['status'] = 1;
		$return['code'] = $response["CODE"];
		$return['rawout'] = htmlspecialchars($response["DESCRIPTION"]);
	}
	return $return;
}


function ispapi_config($params) {
	$config = array();

	if ( $params["this_registrar_config"]["test"] == "1" ) {
		$config["url"] = $params["this_registrar_config"]["turl"];
	}
	else {
		$config["url"] = $params["this_registrar_config"]["url"];
	}

	if ( $params["this_registrar_config"]["secure"]=="1" ) {
		$config["url"] = 'https://'.$config["url"];
	}
	else {
		$config["url"] = 'http://'.$config["url"];
	}

	$config["login"] = $params["this_registrar_config"]["username"];
	$config["password"] = $params["this_registrar_config"]["password"];

	return $config;
}


function ispapi_call($command, &$config) {
	global $queue_debug_mode;
	$command = ispapi_encode_command($command);
	if ( $queue_debug_mode ) {
		echo "Debug-COMMAND\n{";
		print_r(htmlentities($command));
		echo "}\n";
	}
	$response = ispapi_call_raw($command, $config);
	if ( $queue_debug_mode ) {
		echo "Debug-RESPONSE\n{";
		print_r(htmlentities($response));
		echo "}\n";
	}

        return ispapi_parse_response($response);
}


function ispapi_call_raw($command, &$config) {
	$args = array();
	$url = $config["url"];
	if ( isset($config["login"]) )
		$args["s_login"] = $config["login"];
	if ( isset($config["password"]) )
		$args["s_pw"] = $config["password"];
	if ( isset($config["user"]) )
		$args["s_user"] = $config["user"];
	if ( isset($config["entity"]) )
		$args["s_entity"] = $config["entity"];
	$args["s_command"] = $command;
	$config["curl"] = curl_init($url);
	if ( $config["curl"] === FALSE ) {
		return "[RESPONSE]\nCODE=423\nAPI access error: curl_init failed\nEOF\n";
	}
	$postfields = array();
	foreach ( $args as $key => $value ) {
		$postfields[] = urlencode($key)."=".urlencode($value);
	}
	$postfields = implode('&', $postfields);

	curl_setopt( $config["curl"], CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt( $config["curl"], CURLOPT_SSL_VERIFYHOST, 0);

	curl_setopt( $config["curl"], CURLOPT_POST, 1 );
	curl_setopt( $config["curl"], CURLOPT_POSTFIELDS, $postfields );
	curl_setopt( $config["curl"], CURLOPT_HEADER, 0 );
	curl_setopt( $config["curl"], CURLOPT_RETURNTRANSFER , 1 );
	$response = curl_exec($config["curl"]);
	return $response;
}



function ispapi_encode_command( $commandarray ) {
    if (!is_array($commandarray)) return $commandarray;
    $command = "";
    foreach ( $commandarray as $k => $v ) {
        if ( is_array($v) ) {
	    $v = ispapi_encode_command($v);
            $l = explode("\n", trim($v));
            foreach ( $l as $line ) {
                $command .= "$k$line\n";
	    }
        }
        else {
            $v = preg_replace( "/\r|\n/", "", $v );
            $command .= "$k=$v\n";
        }
    }
    return $command;
}



function ispapi_parse_response ( $response ) {
    if (is_array($response)) return $response;
    if (!$response) return array( "CODE" => "423", "DESCRIPTION" => "Empty response from API");
    $hash = array("PROPERTY" => array());
    $rlist = explode( "\n", $response );
    foreach ( $rlist as $item ) {
        if ( preg_match("/^([^\=]*[^\t\= ])[\t ]*=[\t ]*(.*)$/", $item, $m) ) {
            $attr = $m[1];
            $value = $m[2];
            $value = preg_replace( "/[\t ]*$/", "", $value );
            if ( preg_match( "/^property\[([^\]]*)\]/i", $attr, $m) ) {
                $prop = strtoupper($m[1]);
                $prop = preg_replace( "/\s/", "", $prop );
                if ( in_array($prop, array_keys($hash["PROPERTY"])) ) {
                    array_push($hash["PROPERTY"][$prop], $value);
                }
                else {
                     $hash["PROPERTY"][$prop] = array($value);
                }
            }
            else {
                $hash[strtoupper($attr)] = $value;
            }
        }
    }
    $hash["RAW"] = $response;
    return $hash;
}




?>
